//+------------------------------------------------------------------+ 
//|                                                classical rsi.mq4 | 
//+------------------------------------------------------------------+ 
#property copyright "mladen"
#property link      "mladenfx@gmail.com" 

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int    RsiPeriod = 14;
extern int    RsiPrice  = PRICE_CLOSE; 

//
//
//
//
//

double rsi[];
double prices[];

//+------------------------------------------------------------------+  
//|                                                                  |
//+------------------------------------------------------------------+ 

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,rsi);
      SetIndexBuffer(1,prices);
            RsiPeriod = MathMax(RsiPeriod,1);
   IndicatorShortName("classical rsi ("+RsiPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+  
//|                                                                  |
//+------------------------------------------------------------------+ 
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(i=limit; i>=0; i--)
      {
         prices[i] = iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i);
         rsi[i]    = cRsi(RsiPeriod,i);
      }
   return(0);
}

//+------------------------------------------------------------------+  
//|                                                                  |
//+------------------------------------------------------------------+ 
//
//
//
//
//

double rsiWork[][2];
double cRsi(double period,int i)
{
   if (ArrayRange(rsiWork,0)!=Bars) ArrayResize(rsiWork,Bars);
   
   //
   //
   //
   //
   //

   int r = Bars-i-1;
      if (r<2)
      {
         rsiWork[r][0] =         prices[i]-prices[i+1];
         rsiWork[r][1] = MathAbs(prices[i]-prices[i+1]);
         return(0);
      }         
   
      //
      //
      //
      //
      //
      
      double sf     = 1.0/period;
      double change = prices[i]-prices[i+1];
         rsiWork[r][0] = rsiWork[r-1][0]+sf*(        change -rsiWork[r-1][0]);
         rsiWork[r][1] = rsiWork[r-1][1]+sf*(MathAbs(change)-rsiWork[r-1][1]);
   if (rsiWork[r][1]!=0)
         return(50*(rsiWork[r][0]/rsiWork[r][1]+1));
   else  return(0);         
}